// $Id: Field.java 27 2008-03-02 18:27:32Z matsu $
package com.piece_framework.piece_ide.form_designer.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public final class Field {
    private String fName;
    private String fDescription;
    private boolean fRequired;
    private String fMessage;
    private List<Validator> fValidators;

    public Field(final String name) {
        if (name == null) {
            throw new NullPointerException();
        }
        fName = name;
        fDescription = "";
        fRequired = false;
        fMessage = "";
        fValidators = new ArrayList<Validator>();
    }

    public String getName() {
        return fName;
    }

    public void setName(final String name) {
        if (name == null) {
            throw new NullPointerException();
        }
        fName = name;
    }

    public String getDescription() {
        return fDescription;
    }

    public void setDescription(final String description) {
        if (description == null) {
            throw new NullPointerException();
        }
        fDescription = description;
    }

    public boolean isRequired() {
        return fRequired;
    }

    public void setRequired(final boolean required) {
        fRequired = required;
    }

    public String getMessage() {
        return fMessage;
    }

    public void setMessage(final String message) {
        if (fMessage == null) {
            throw new NullPointerException();
        }
        fMessage = message;
    }

    public List<Validator> getValidators() {
        return Collections.unmodifiableList(fValidators);
    }

    public void addValidator(final Validator validator) {
        if (validator == null) {
            throw new NullPointerException(); 
        }
        fValidators.add(validator);
    }

    public void removeValidator(final Validator validator) {
        if (validator == null) {
            throw new NullPointerException(); 
        }
        fValidators.remove(validator);
    }
}
