package com.piece_framework.piece_ide.form_designer.model;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

public class Validator {
    private String fName;
    private String fMessage;
    private Map<String, String> fRules;

    public Validator(final String name, final Map<String, String> rules) {
        if (name == null) {
            throw new NullPointerException();
        }
        if (rules == null) {
            throw new NullPointerException();
        }

        fName = name;
        fMessage = "";
        fRules = new LinkedHashMap<String, String>();
        Iterator<String> iterator = rules.keySet().iterator();
        while (iterator.hasNext()) {
            String key = iterator.next();
            fRules.put(key, rules.get(key));
        }
    }

    public String getName() {
        return fName;
    }

    public String getMessage() {
        return fMessage;
    }

    public void setMessage(final String message) {
        fMessage = message;
    }

    public Map<String, String> getRules() {
        return Collections.unmodifiableMap(fRules);
    }

    public void setRule(final String name, final String value) {
        if (name == null) {
            throw new NullPointerException();
        }
        if (value == null) {
            throw new NullPointerException();
        }

        fRules.put(name, value);
    }
}
