// $Id: FieldDetailsPage.java 23 2008-03-02 16:51:09Z matsu $
package com.piece_framework.piece_ide.form_designer.ui;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.IDetailsPage;
import org.eclipse.ui.forms.IFormPart;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.widgets.Section;

public class FieldDetailsPage implements IDetailsPage {
    private IManagedForm fManagedForm;

    private List<AbstractFieldDetailsSection> fSections;
    private Composite fParent;

    public void createContents(Composite parent) {
        GridLayout layout = new GridLayout(1, false);
        layout.marginHeight = 0;
        layout.marginWidth = 0;
        parent.setLayout(layout);

        fParent = parent;
    }

    public void commit(boolean onSave) {
    }

    public void dispose() {
    }

    public void initialize(IManagedForm form) {
        fManagedForm = form;
    }

    public boolean isDirty() {
        return false;
    }

    public boolean isStale() {
        return false;
    }

    public void refresh() {
    }

    public void setFocus() {
    }

    public boolean setFormInput(Object input) {
        return false;
    }

    public void selectionChanged(IFormPart part,
                                 ISelection selection) {
        boolean fieldChange = true;
        if (fSections != null) {
            for (AbstractFieldDetailsSection section : fSections) {
                if (section.getSectionPart() == part) {
                    fieldChange = false;
                }
            }
        }

        if (fieldChange) {
            if (fSections != null) {
                for (AbstractFieldDetailsSection section : fSections) {
                    section.getSectionPart().getSection().dispose();
                }
                fSections.removeAll(
                        new ArrayList<AbstractFieldDetailsSection>());
            }

            fSections = new ArrayList<AbstractFieldDetailsSection>();
            fSections.add(new FieldDetailsGeneralSection());
            fSections.add(new FieldDetailsValidatorSection());

            for (AbstractFieldDetailsSection section : fSections) {
                section.createContents(
                        fManagedForm.getToolkit().createSection(
                                fParent, Section.TITLE_BAR),
                                fManagedForm);
            }
            fParent.pack();
        }

        for (AbstractFieldDetailsSection section : fSections) {
            section.selectionChanged(part, selection);
        }
    }
}
